// 自定义指令
// 自动注入js结尾的文件
const modulesFiles = require.context('./modules', true, /.js$/)
const directives = modulesFiles.keys().reduce((modules, modulePath) => {
    const moduleName = modulePath.replace(/^.\/(.*)\.js/, '$1')
    const value = modulesFiles(modulePath)
    modules[moduleName] = value.default
    return modules
}, {})

export default {
    /**
     * 批量引入
     * @param Vue
     * @param keys 数组，按需引入所需要的指令，如['copytouch','stretchheight']
     */
    install(Vue, option) {
        //全量引入
        Object.keys(directives).forEach(key => {
            directives[key].install(Vue, option)
        })
    }
}
