//  <button v-copytouch="copytouch">复制与点击不冲突</button>
const copytouch = {
    // install方法
    install(Vue, option) {
        Vue.directive('copytouch', {
            bind(el, binding) {
                copytouch.bind(el, binding)
            },
            unbind(el) {
                copytouch.unbind(el)
            },
            componentUpdated(el, binding) {
                copytouch.componentUpdated(el, binding)
            },
        })
    },
    bind: function (el, binding) {
        if (typeof binding.value !== 'function') {
            throw 'callback must be a function'
        }
        // 鼠标按下事件
        // el.onmousedown = (e) => {
        function start(e) {
            let startX = e.clientX
            document.onmouseup = (evt) => {
                // e.button === 0:左键被点击
                // e.button === 1:鼠标中间滚轮被点击
                // e.button === 2:右键被点击
                // e.button === 3: `Browser Back`按钮被点击
                // e.button === 4: `Browser Forward`按钮被点击
                // 只有鼠标左键点击才触发事件
                if (e.button !== 0) return
                let endX = evt.clientX
                let moveX = endX - startX
                document.onmousemove = null
                document.onmouseup = null
                el.releaseCapture && el.releaseCapture()
                if (Math.abs(moveX) < 10) {
                    //
                    binding.value && binding.value(e)
                }
            }
            return true
        }

        el.addEventListener('mousedown', start)
    },
    // 当传进来的值更新的时候触发
    componentUpdated(el, {value}) {
        el.$value = value
    },
    // 指令与元素解绑的时候，移除事件绑定
    unbind(el) {
        el.removeEventListener('mousedown', el.handler)
    }
}

export default copytouch
