//  <button v-debounce="debounceClick">防抖</button>
const debounce = {
    // install方法
    install(Vue, option) {
        //debounceDuration 防抖时间
        let debounceDuration = 300
        if (option && option.debounceDuration && typeof option.debounceDuration === 'number') {
            debounceDuration = option.debounceDuration
        }
        Vue.directive('debounce', {
            inserted(el, binding) {
                debounce.inserted(el, binding, debounceDuration)
            },
            unbind(el) {
                debounce.unbind(el)
            },
        })
    },
    inserted: function (el, binding, debounceDuration) {
        let timer
        el.__debounceListener__ = () => {
            if (timer) {
                clearTimeout(timer)
            }
            timer = setTimeout(() => {
                binding.value()
            }, debounceDuration)
        }
        el.addEventListener('click', el.__debounceListener__)
    },
    // 指令与元素解绑的时候，移除事件绑定
    unbind(el) {
        document.removeEventListener('click', el.__debounceListener__)
    }
}

export default debounce
