// <div v-domresize="onResize">这个div大小变化时响应事件</div>
const domresize = {
    // install方法
    install(Vue, option) {
        Vue.directive('domresize', {
            bind(el, binding) {
                domresize.bind(el, binding)
            },
            unbind(el) {
                domresize.unbind(el)
            },
        })
    },
    // value -> onResize
    bind(el, {value}) {
        // console.log("resize 绑定")
        let width = ''
        let height = ''

        function isReize() {
            const style = document.defaultView.getComputedStyle(el)
            if (width !== style.width || height !== style.height) {
                value({width: style.width, height: style.height, el}) // 关键(这传入的是函数,所以执行此函数)
            }
            width = style.width
            height = style.height
        }

        el.__vueSetInterval__domresize__ = setInterval(isReize, 300)
    },
    // 指令与元素解绑的时候，移除事件绑定
    unbind(el) {
        // console.log(el, "解绑");
        clearInterval(el.__vueSetInterval__domresize__)
    }
}

export default domresize
