// 相当于绑定一个事件，点击这个div以外的内容时，触发回调函数。
// 参数是回调函数，一般处理关闭弹窗的逻辑。
// <div v-maskclosable="()=>{visable = false}"></div>
const maskclosable = {
  // install方法
  install(Vue, option) {
    Vue.directive('maskclosable', {
      bind(el, binding) {
        maskclosable.bind(el, binding)
      },
      unbind(el) {
        maskclosable.unbind(el)
      },
    })
  },
  bind(el, binding) {
    if (typeof binding.value !== 'function') {
      throw 'callback must be a function'
    }
    el.__maskListener__ = (e) => {
      const userCon = el
      if (userCon && !userCon.contains(e.target)) {
        // 执行回调
        binding.value()
      }
    }
    // 点击任意位置关闭弹窗区域
    document.addEventListener('click', el.__maskListener__)
  },
  // 指令与元素解绑的时候，移除监听事件
  unbind(el) {
    document.removeEventListener('click', el.__maskListener__)
  }
}

export default maskclosable
