// <div v-stretchheight="onResize">这个div大小变化时响应事件</div>
const stretchheight = {
    // install方法
    install(Vue, option) {
        Vue.directive('stretchheight', {
            bind(el, binding) {
                stretchheight.bind(el, binding)
            },
            unbind(el) {
                stretchheight.unbind(el)
            },
        })
    },
    // value -> onResize
    bind(el, {value}) {
        let lastHeight = null

        function isReize() {
            if (el.offsetHeight === 0) return
            let top = 0

            function sumTop(el) {
                top += el.offsetTop;
                (el.offsetParent) && sumTop(el.offsetParent)
            }

            sumTop(el)

            let height = document.documentElement.clientHeight - top
            if (height > 0) {
                lastHeight = height
                value({height, el})
            }
        }

        el.__vueSetInterval__stretchheight__ = setInterval(isReize, 300)
    },
    // 指令与元素解绑的时候，移除事件绑定
    unbind(el) {
        // console.log(el, "解绑");
        clearInterval(el.__vueSetInterval__stretchheight__)
    }
}

export default stretchheight
