/**
 * @description: 复制到剪切板方法2，用传统的document.execCommand，兼容性问题最好，不过未来注定会废弃
 * @param text {string} 要复制的String文本
 * @return {Promise<void>}
 * @author: hekai
 */
function copyText(text) {
    return new Promise((resolve, reject) => {
        try {
            const input = document.createElement('textarea')
            input.value = text
            document.body.appendChild(input)
            input.select()
            if (document.execCommand('copy')) {
                document.execCommand('copy')
                resolve()
            } else {
                reject(new Error('复制失败！浏览器不支持execCommand方法！'))
            }
            document.body.removeChild(input)
        } catch (e) {
            reject(new Error(`复制失败！${e}`))
        }
    })

}

export default copyText
