import isStringEmpty from "./isStringEmpty";

/**
 * 提取url中的文件名
 * @param url {string} 网络地址
 * @param isRemoveSuffix {boolean} 是否去除文件名后缀，默认false
 * @returns {string}
 */
function findFileName(url, isRemoveSuffix = false) {
    if (isStringEmpty(url)) {
        return ''
    }
    let urlArr = url.split('?')
    let appU = urlArr[0].split('/')
    let result = appU[appU.length - 1]
    if (isRemoveSuffix) {
        result = result.substring(0, result.lastIndexOf("."))
    }
    return result
}

export default findFileName
