/**
 * 遍历树形结构，你可以理解为Tree的数组forEach函数。
 * @param tree {array} 树形数据
 * @param func {function} 遍历函数
 * @param children {string} children的属性名
 * @returns {BigInt64Array}
 */
function forEachTree(tree, func, children = 'children') {
    try {
        tree.forEach((node) => {
            func({...node})
            node[children] && (node[children] = forEachTree(node[children], func, children))
        })
    } catch (e) {
        console.error('forEachTree.js [easy-project-vue error]:', e)
    }
}

export default forEachTree
