import isNumberEmpty from "./isNumberEmpty";

/**
 * 将毫秒转成时：分：秒
 * @param value 毫秒
 * @returns {string}
 */
export function formatSeconds(value) {
  if (isNumberEmpty(value)) return '00:00:00'
  
  // 传进来的是 毫秒 形式，在这里除1000将其转为 秒 形式
  let theTime = parseInt((value /= 1000)) // 秒
  let theTime1 = 0 // 分
  let theTime2 = 0 // 小时
  if (theTime > 60) {
    theTime1 = parseInt(theTime / 60)
    theTime = parseInt(theTime % 60)
    if (theTime1 > 60) {
      theTime2 = parseInt(theTime1 / 60)
      theTime1 = parseInt(theTime1 % 60)
    }
  }
  let result = '' + parseInt(theTime)
  if (result < 10) {
    result = '0' + result
  }
  if (theTime1 > 0) {
    result = '' + parseInt(theTime1) + ':' + result
    if (theTime1 < 10) {
      result = '0' + result
    }
  } else {
    result = '00:' + result
  }
  if (theTime2 > 0) {
    result = '' + parseInt(theTime2) + ':' + result
    if (theTime2 < 10) {
      result = '0' + result
    }
  } else {
    result = '00:' + result
  }
  return result
}
