import isArrayEmpty from "./isArrayEmpty";

/**
 * 树形结构转数组
 * @param array {array} 树数据
 * @param children {string} children的属性名
 * @returns {[]}
 */
function getArrayByTree(array, children = 'children') {
    if (isArrayEmpty(array)) {
        return []
    }

    const result = []

    function loop(data) {
        result.push(data);
        let child = data[children]
        if (child) {
            for (let i = 0; i < child.length; i++) {
                loop(child[i])
            }
        }
    }

    array.forEach(item => {
        loop(item)
    })
    return result
}

export default getArrayByTree
