import deepClone from "./deepClone";
import isArrayEmpty from "./isArrayEmpty";

/**
 * @description:
 * @param {array} array 数据源
 * @param {string} id 子节点id 属性名
 * @param {string} parentId 父节点id 属性名
 * @param {string} children 子节点list属性名
 * @param {string} rootId 根节点id 值
 * @return {array}
 * @author: hekai
 */
function getTreeByArray(array, id = 'id', parentId = 'parentId', children = 'children', rootId = '0') {
	if (isArrayEmpty(array)) {
		return []
	}

	// 对源数据深度克隆
	const cloneData = deepClone(array)
	// 循环所有项
	return cloneData.filter(father => {
		let branchArr = cloneData.filter(child => {
			// 返回每一项的子级数组
			return father[id] === child[parentId]
		})
		if (branchArr.length > 0) {
			father[children] = branchArr
		}
		// 返回第一层
		return father[parentId] == rootId
	})
}

export default getTreeByArray
