import isArrayEmpty from "./isArrayEmpty";

/**
 * @description: 根据对象数组的属性分组
 * @param {*} array 数组
 * @param {*} key 依据的属性
 * @param {*} groupName 分类后的数组名，默认叫'allData'
 * @return {*}
 * @author: hekai
 */
function groupArray(array, key, groupName = 'allData') {
    if (isArrayEmpty(array)) {
        return []
    }

    const arr = []
    const obj = {}
    array.forEach(element => {
        if (!obj[element[key]]) {
            arr.push({
                [key]: element[key],
                [groupName]: new Array(element)
            })

            obj[element[key]] = element
        } else {
            arr.forEach(ele => {
                if (ele[key] === element[key]) {
                    ele[groupName].push(element)
                }
            })
        }
    })
    return arr
}

export default groupArray
