/**
 * 保留小数后几位
 * @param num {*} 转换原数据（数字值 ）
 * @param digit {number} 保留位数（数字值）
 * @param isRounding 是否使用四舍五入的方式（布尔值）,否则向下取整
 * @returns {number} 保留两位小数的结果
 */
import isNumberEmpty from "./isNumberEmpty";

function keepDecimal(num, digit = 2, isRounding = true) {
    //初始化保留的位数
    let saveDigit = Math.pow(10, digit)
    //未传要转换的参数
    if (isNumberEmpty(num)) {
        console.error(`keepDecimalDigits.js [easy-project-vue error]: TypeError: A number type is required, but it is actually ${typeof num} type! or num is 0!`)
        return 0
    }
    //传值正常
    //不使用四舍五入方式，使用向下取整
    if (!isRounding) {
        return Math.floor(num * saveDigit) / saveDigit
    }
    //使用四舍五入方式
    return num.toFixed(digit)

}

export default keepDecimal

