/**
 * 遍历树形结构，并根据func生成新节点，你可以理解为Tree的数组map函数。
 * @param tree {array} 树形数据
 * @param func {function} 更新函数
 * @param children {string} children的属性名
 * @returns {array}
 */
function mapTree(tree, func, children = 'children') {
    try {
        let newData = tree.map((node) => {
            return func({...node})
        })
        newData.forEach(node => node[children] && (node[children] = mapTree(node[children], func, children)))
        return newData
    } catch (e) {
        console.error('mapTree.js [easy-project-vue error]:', e)
        return []
    }
}

export default mapTree
