import isStringEmpty from "./isStringEmpty";

/**
 * 去除一个字符串里的HTML标签
 * @param str {string} 字符串
 * @param isTrim {boolean} 是否去除空格、换行等空白字符，默认值为true
 * @param isRemoveCharacterEntities {boolean} 是否去除字符实体（character entities，如不间断空格(&nbsp;)
 * @returns {string} 去除HTML标签后的转换结果
 */
function removeHTMLTag(str, isTrim = true,isRemoveCharacterEntities = true) {
    if (isStringEmpty(str)) return ''

    //去除HTML tag
    str = str.replace(/<\/?[^>]*>/g, '');
    if (isTrim) {
        //去除多余空行
        str = str.replace(/[\n|\s|\r| | ]*/g, '');
    }
    if(isRemoveCharacterEntities){
        //去除字符实体
        str = str.replace(/(&(lt|gt|nbsp|amp|quot);)*/ig, '')
    }
    return str
}



export default removeHTMLTag
